#include "squidwall.h"

/**
 * Copyright (C) 2005-2006 Tino Reichardt
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License Version 2, as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

int check_host(int *todo)
{
	struct list_head *l;
	struct squidwall_acl *acl;

	bfilter_host      = 0;
	bcfilter_host     = 0;
	brfilter_host     = 0;
	cfilter_host      = 0;
	crfilter_host     = 0;
	pfilter_host      = 0;
	ufilter_host      = 0;
	ufilter_md5_host  = 0;
	ufilter_sha1_host = 0;
	urfilter_host     = 0;
	wfilter_host      = 0;
	wrfilter_host     = 0;

	list_for_each(l, &hosts) {
		acl = list_entry(l, struct squidwall_acl, list);

		/* check ip */
		if (case_equals(acl->filename.s, ip.s)) {
			debug_s2(DEBUG_CHECK_HOST, "setze filter von ip ", ip.s);
			bfilter_host      = &acl->bfilter;
			bcfilter_host     = &acl->bcfilter;
			brfilter_host     = &acl->brfilter;
			cfilter_host      = &acl->cfilter;
			crfilter_host     = &acl->crfilter;
			pfilter_host      = &acl->pfilter;
			ufilter_host      = &acl->ufilter;
			ufilter_md5_host  = &acl->ufilter_md5;
			ufilter_sha1_host = &acl->ufilter_sha1;
			urfilter_host     = &acl->urfilter;
			wfilter_host      = &acl->wfilter;
			wrfilter_host     = &acl->wrfilter;
			set(*todo, acl->todo);
			return acl->flags;
		}

		/* check hostname */
		if (case_equals(acl->filename.s, host.s)) {
			debug_s2(DEBUG_CHECK_HOST, "setze filter von host ", host.s);
			bfilter_host      = &acl->bfilter;
			bcfilter_host     = &acl->bcfilter;
			brfilter_host     = &acl->brfilter;
			cfilter_host      = &acl->cfilter;
			crfilter_host     = &acl->crfilter;
			pfilter_host      = &acl->pfilter;
			ufilter_host      = &acl->ufilter;
			ufilter_md5_host  = &acl->ufilter_md5;
			ufilter_sha1_host = &acl->ufilter_sha1;
			urfilter_host     = &acl->urfilter;
			wfilter_host      = &acl->wfilter;
			wrfilter_host     = &acl->wrfilter;
			set(*todo, acl->todo);
			return acl->flags;
		}

	}

	return ACL_DEFAULT;
}
