#include "squidwall.h"

/**
 * Copyright (C) 2005-2006 Tino Reichardt
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License Version 2, as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

int check_user(int *todo)
{
	struct list_head *l;
	struct squidwall_acl *acl;

	bfilter_user      = 0;
	bcfilter_user     = 0;
	brfilter_user     = 0;
	cfilter_user      = 0;
	crfilter_user     = 0;
	pfilter_user      = 0;
	ufilter_user      = 0;
	ufilter_md5_user  = 0;
	ufilter_sha1_user = 0;
	urfilter_user     = 0;
	wfilter_user      = 0;
	wrfilter_user     = 0;

	list_for_each(l, &users) {
		acl = list_entry(l, struct squidwall_acl, list);

		/* check the username */
		if (case_equals(acl->filename.s, user.s)) {
			debug_s2(DEBUG_CHECK_USER, "setze filter von user ", user.s);
			bfilter_user      = &acl->bfilter;
			bcfilter_user     = &acl->bcfilter;
			brfilter_user     = &acl->brfilter;
			cfilter_user      = &acl->cfilter;
			crfilter_user     = &acl->crfilter;
			pfilter_user      = &acl->pfilter;
			ufilter_user      = &acl->ufilter;
			ufilter_md5_user  = &acl->ufilter_md5;
			ufilter_sha1_user = &acl->ufilter_sha1;
			urfilter_user     = &acl->urfilter;
			wfilter_user      = &acl->wfilter;
			wrfilter_user     = &acl->wrfilter;
			set(*todo, acl->todo);
			return acl->flags;
		}

	}

	return ACL_DEFAULT;
}
