#include "squidwall.h"

/**
 * Copyright (C) 2005-2006 Tino Reichardt
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License Version 2, as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

/**
 * url whitelist checking
 */

int check_wlist(void)
{
	struct squidwall_string *string;
	struct squidwall_regex *regex;
	struct named_regex *nr;
	struct list_head *l;
	unsigned int j, k;
	char *file, *str;

	if (wfilter_host)
	for (j=0; j < wfilter_host->len; j += str_len(wfilter_host->s+j)+1)
	list_for_each(l, &wfilter) {
		string = list_entry(l, struct squidwall_string, list);
		file = wfilter_host->s+j;
		if (str_equal(file, string->filename.s))
		for (k=0; k < string->strings.len;
				k += str_len(string->strings.s+k)+1) {
			str = string->strings.s+k;
			if (case_strstr(squid_url, str)) {
				return ACL_ALLOW;
			}
		}
	}

	if (wfilter_user)
	for (j=0; j < wfilter_user->len; j += str_len(wfilter_user->s+j)+1)
	list_for_each(l, &wfilter) {
		string = list_entry(l, struct squidwall_string, list);
		file = wfilter_user->s+j;
		if (str_equal(file, string->filename.s))
		for (k=0; k < string->strings.len;
				k += str_len(string->strings.s+k)+1) {
			str = string->strings.s+k;
			if (case_strstr(squid_url, str)) {
				return ACL_ALLOW;
			}
		}
	}

	if (wrfilter_host && wrfilter_host->len)
	for (j=0; j < wrfilter_host->len; j += str_len(wrfilter_host->s+j)+1)
	list_for_each(l, &wrfilter) {
		file = wrfilter_host->s+j;
		regex = list_entry(l, struct squidwall_regex, list);
		if (str_equal(file, regex->filename.s))
		for (k=0; k < array_length(&regex->regex, sizeof(struct named_regex)); k++) {
			nr = array_get(&regex->regex, sizeof(struct named_regex), k);
			if (regexec(&nr->r, squid_url, 0, 0, nr->eflags) == 0) {
				return ACL_ALLOW;
			}
		}
	}

	if (wrfilter_user && wrfilter_user->len)
	for (j=0; j < wrfilter_user->len; j += str_len(wrfilter_user->s+j)+1)
	list_for_each(l, &wrfilter) {
		file = wrfilter_user->s+j;
		regex = list_entry(l, struct squidwall_regex, list);
		if (str_equal(file, regex->filename.s))
		for (k=0; k < array_length(&regex->regex, sizeof(regex_t)); k++) {
			nr = array_get(&regex->regex, sizeof(regex_t), k);
			if (regexec(&nr->r, squid_url, 0, 0, nr->eflags) == 0) {
				return ACL_ALLOW;
			}
		}
	}

	return ACL_DENY;
}
