#!/bin/sh

lesspipe() {
  case "$1" in
  *.tar) tar tvvf "$1" 2>/dev/null ;; # View contents of .tar and .tgz files
  *.tgz) tar tzvvf "$1" 2>/dev/null ;;
  *.tar.gz) tar tzvvf "$1" 2>/dev/null ;;
  *.tar.Z) tar tzvvf "$1" 2>/dev/null ;;
  *.tar.z) tar tzvvf "$1" 2>/dev/null ;;
  *.tar.bz2) tar tjvvf "$1" 2>/dev/null ;;
  *.Z) gzip -dc "$1" 2>/dev/null ;; # View compressed files correctly
  *.z) gzip -dc "$1" 2>/dev/null ;;
  *.zip) unzip -l "$1" 2>/dev/null ;;
  *.rpm) rpm -qpvl "$1" 2>/dev/null ;;
  *.1|*.2|*.3|*.4|*.5|*.6|*.7|*.8|*.9|*.n|*.man) # *roff src?
    if file -L "$1" | grep roff 1> /dev/null ; then
      nroff -S -mandoc "$1"
    fi ;;
  *.1.gz|*.2.gz|*.3.gz|*.4.gz|*.5.gz|*.6.gz|*.7.gz|*.8.gz|*.9.gz|*.n.gz|*.man.gz) # compressed *roff src?
    if gzip -dc "$1" | file - | grep roff 1> /dev/null ; then
      gzip -dc "$1" | nroff -S -mandoc -
    fi ;;
  *.1.bz2|*.2.bz2|*.3.bz2|*.4.bz2|*.5.bz2|*.6.bz2|*.7.bz2|*.8.bz2|*.9.bz2|*.n.bz2|*.man.bz2) # compressed *roff src?
    if bzip2 -dc "$1" | file - | grep roff 1> /dev/null ; then
      bzip2 -dc "$1" | nroff -S -mandoc -
    fi ;;
  *.gz) gzip -dc "$1"  2>/dev/null ;;
  *.bz2) bzip2 -dc "$1" 2>/dev/null ;;
  access.*) cat $1|conv2date ;;
  @4*|current|squidwall.log) [ "x`dd if=$1 bs=1 count=1 2>/dev/null`" == "x@" ] && cat $1|tai64nlocal ;;
  esac
}

lesspipe "$1"
