#ifndef SW_DEBUG_H
#define SW_DEBUG_H

/**
 * Copyright (C) 2005-2006 Tino Reichardt
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License Version 2, as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

/* debugging */
#if DEBUG_LEVEL
extern int debug_level;
extern void debug(int level, char *msg);
extern void debug_s(int level, char *s);
extern void debug_s2(int level, char *s1, char *s2);
extern void debug_s3(int level, char *s1, char *s2, char *s3);
extern void debug_sa(int level, char *msg, stralloc *sa);
extern void debug_long(int level, char *msg, long num);
extern void debug_ulong(int level, char *msg, unsigned long num);
extern void log_long(unsigned long n);
#define die_nomem() panic("nomem() @ file:" __FILE__ "!")
#else
#define debug(l,m)
#define debug_s(l,s)
#define debug_s2(l,s,s2)
#define debug_s3(l,s,s2,s3)
#define debug_sa(l,m,sa)
#define debug_long(l,m,n)
#define debug_ulong(l,m,n)
#define log_long(l,m,n)
#define die_nomem() panic("nomem()")
#endif

#endif
