#include "squidwall.h"

/**
 * Copyright (C) 2005-2006 Tino Reichardt
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License Version 2, as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

static stralloc lastmsg;

/**
 * panic - this function is only called, if strange things happen :)
 * - redirectors do never exit, so we do not exit here!
 * - log only new messages
 *
 * @param msg  message, which should be logged
 * @return     ACL_DEFAULT, so we can use statements like "return panic(x)"
 */
int panic(char *msg)
{
	static int firstcall=1;
	
	if (firstcall) {
		stralloc_init(&lastmsg);
		firstcall=0;
	} else {
		/* look, if the msg is exact the last one */
		if (str_equal(msg, lastmsg.s)) return ACL_DEFAULT;
	}

	log_headline("panic"); log_s(msg); log_s("\n");
	log_flush();

	if (!stralloc_copys(&lastmsg, msg)) die_nomem();

	return ACL_DEFAULT;
}
