#include "squidwall.h"

/**
 * Copyright (C) 2005-2006 Tino Reichardt
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License Version 2, as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

/**
 * scan_url - extract host and path information from the squid url
 *
 * needs these global variables:
 *  char *squid_url   | http://www.foo.org/path/to/bar.jpg
 *  stralloc url_host | www.foo.org
 *  stralloc url_path | /path/to/bar.jpg
 *
 * @return nothing
 */
void scan_url(void)
{
	stralloc sa;
	char *x;

	x=squid_url;
	if (str_start(x, "ftp://"))   { x+=6; }
	if (str_start(x, "http://"))  { x+=7; }
	if (str_start(x, "https://")) { x+=8; }

	stralloc_init(&sa);
	if (!stralloc_copys(&sa, x)) die_nomem();

	/* www.domainname.de/xyz -> xyz isn't wanted (md5, sha1 lists!) */
	x = sa.s;
	while (*x++) {
		if (*x == '/') {
			*x=0;
			if (!stralloc_copys(&url_host, sa.s)) die_nomem();
			if (!stralloc_copys(&url_path, x+1)) die_nomem();
			stralloc_free(&sa);
			return;
		}
	}
	if (!stralloc_copys(&url_host, sa.s)) die_nomem();
	if (!stralloc_copys(&url_path, "/")) die_nomem();
	stralloc_free(&sa);

	return;
}
